<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>EscherRecord (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="EscherRecord (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":6,"i4":6,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":6,"i11":6,"i12":10,"i13":10,"i14":10,"i15":9,"i16":10,"i17":10,"i18":6,"i19":10,"i20":10,"i21":10,"i22":10,"i23":10,"i24":10,"i25":10,"i26":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/EscherRecord.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../index-all.html">Index</a></li>
        <li><a href="../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../org/apache/poi/ddf/EscherPropertyMetaData.html"
               title="class in org.apache.poi.ddf"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../org/apache/poi/ddf/EscherRecordFactory.html"
               title="interface in org.apache.poi.ddf"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../index.html?org/apache/poi/ddf/EscherRecord.html" target="_top">Frames</a></li>
        <li><a href="EscherRecord.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.ddf</div>
    <h2 title="Class EscherRecord" class="title">Class EscherRecord</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.ddf.EscherRecord</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Implemented Interfaces:</dt>
                    <dd>java.lang.Cloneable</dd>
                </dl>
                <dl>
                    <dt>Direct Known Subclasses:</dt>
                    <dd><a href="../../../../org/apache/poi/ddf/AbstractEscherOptRecord.html"
                           title="class in org.apache.poi.ddf">AbstractEscherOptRecord</a>, <a
                            href="../../../../org/apache/poi/ddf/EscherBlipRecord.html"
                            title="class in org.apache.poi.ddf">EscherBlipRecord</a>, <a
                            href="../../../../org/apache/poi/ddf/EscherBSERecord.html"
                            title="class in org.apache.poi.ddf">EscherBSERecord</a>, <a
                            href="../../../../org/apache/poi/ddf/EscherChildAnchorRecord.html"
                            title="class in org.apache.poi.ddf">EscherChildAnchorRecord</a>, <a
                            href="../../../../org/apache/poi/ddf/EscherClientAnchorRecord.html"
                            title="class in org.apache.poi.ddf">EscherClientAnchorRecord</a>, <a
                            href="../../../../org/apache/poi/ddf/EscherClientDataRecord.html"
                            title="class in org.apache.poi.ddf">EscherClientDataRecord</a>, <a
                            href="../../../../org/apache/poi/ddf/EscherContainerRecord.html"
                            title="class in org.apache.poi.ddf">EscherContainerRecord</a>, <a
                            href="../../../../org/apache/poi/ddf/EscherDggRecord.html"
                            title="class in org.apache.poi.ddf">EscherDggRecord</a>, <a
                            href="../../../../org/apache/poi/ddf/EscherDgRecord.html"
                            title="class in org.apache.poi.ddf">EscherDgRecord</a>, <a
                            href="../../../../org/apache/poi/hslf/record/EscherPlaceholder.html"
                            title="class in org.apache.poi.hslf.record">EscherPlaceholder</a>, <a
                            href="../../../../org/apache/poi/ddf/EscherSpgrRecord.html"
                            title="class in org.apache.poi.ddf">EscherSpgrRecord</a>, <a
                            href="../../../../org/apache/poi/ddf/EscherSplitMenuColorsRecord.html"
                            title="class in org.apache.poi.ddf">EscherSplitMenuColorsRecord</a>, <a
                            href="../../../../org/apache/poi/ddf/EscherSpRecord.html"
                            title="class in org.apache.poi.ddf">EscherSpRecord</a>, <a
                            href="../../../../org/apache/poi/ddf/EscherTextboxRecord.html"
                            title="class in org.apache.poi.ddf">EscherTextboxRecord</a>, <a
                            href="../../../../org/apache/poi/ddf/UnknownEscherRecord.html"
                            title="class in org.apache.poi.ddf">UnknownEscherRecord</a></dd>
                </dl>
                <hr>
                <br>
                <pre>public abstract class <span class="typeNameLabel">EscherRecord</span>
extends java.lang.Object
implements java.lang.Cloneable</pre>
                <div class="block">The base abstract record from which all escher records are defined. Subclasses will
                    need
                    to define methods for serialization/deserialization and for determining the record size.
                </div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#EscherRecord--">EscherRecord</a></span>()</code>
                                    <div class="block">Create a new instance</div>
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t1" class="tableTab"><span><a
                                    href="javascript:show(1);">Static Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a
                                    href="javascript:show(4);">Abstract Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code><a href="../../../../org/apache/poi/ddf/EscherRecord.html"
                                                              title="class in org.apache.poi.ddf">EscherRecord</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#clone--">clone</a></span>()</code>
                                    <div class="block">Escher records may need to be clonable in the future.</div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#display-java.io.PrintWriter-int-">display</a></span>(java.io.PrintWriter&nbsp;w,
                                    int&nbsp;indent)</code>
                                    <div class="block">The display methods allows escher variables to print the record
                                        names
                                        according to their hierarchy.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>protected int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#fillFields-byte:A-org.apache.poi.ddf.EscherRecordFactory-">fillFields</a></span>(byte[]&nbsp;data,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecordFactory.html"
                                       title="interface in org.apache.poi.ddf">EscherRecordFactory</a>&nbsp;f)</code>
                                    <div class="block">Delegates to fillFields(byte[], int, EscherRecordFactory)</div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>abstract int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#fillFields-byte:A-int-org.apache.poi.ddf.EscherRecordFactory-">fillFields</a></span>(byte[]&nbsp;data,
                                    int&nbsp;offset,
                                    <a href="../../../../org/apache/poi/ddf/EscherRecordFactory.html"
                                       title="interface in org.apache.poi.ddf">EscherRecordFactory</a>&nbsp;recordFactory)</code>
                                    <div class="block">The contract of this method is to deserialize an escher record
                                        including
                                        it's children.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code>protected abstract java.lang.Object[][]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#getAttributeMap--">getAttributeMap</a></span>()</code>
                                    <div class="block">For the purpose of providing toString() and toXml() a subclass
                                        can either override those methods
                                        or provide a Object[][] array in the form { { "Attribute Name (Header)", value,
                                        "optional attribute", value }, ...
                                    </div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code><a href="../../../../org/apache/poi/ddf/EscherRecord.html"
                                                              title="class in org.apache.poi.ddf">EscherRecord</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#getChild-int-">getChild</a></span>(int&nbsp;index)</code>
                                    <div class="block">Returns the indexed child record.</div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>java.util.List&lt;<a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html"
                                        title="class in org.apache.poi.ddf">EscherRecord</a>&gt;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#getChildRecords--">getChildRecords</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>short</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#getInstance--">getInstance</a></span>()</code>
                                    <div class="block">Returns the instance part of the option record.</div>
                                </td>
                            </tr>
                            <tr id="i8" class="altColor">
                                <td class="colFirst"><code>short</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#getOptions--">getOptions</a></span>()</code>
                                    <div class="block">Note that <code>options</code> is an internal field.</div>
                                </td>
                            </tr>
                            <tr id="i9" class="rowColor">
                                <td class="colFirst"><code>short</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#getRecordId--">getRecordId</a></span>()</code>
                                    <div class="block">Return the current record id.</div>
                                </td>
                            </tr>
                            <tr id="i10" class="altColor">
                                <td class="colFirst"><code>abstract java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#getRecordName--">getRecordName</a></span>()</code>
                                    <div class="block">Subclasses should return the short name for this escher record.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i11" class="rowColor">
                                <td class="colFirst"><code>abstract int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#getRecordSize--">getRecordSize</a></span>()</code>
                                    <div class="block">Subclasses should effeciently return the number of bytes required
                                        to
                                        serialize the record.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i12" class="altColor">
                                <td class="colFirst"><code>short</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#getVersion--">getVersion</a></span>()</code>
                                    <div class="block">Returns the version part of the option record.</div>
                                </td>
                            </tr>
                            <tr id="i13" class="rowColor">
                                <td class="colFirst"><code>boolean</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#isContainerRecord--">isContainerRecord</a></span>()</code>
                                    <div class="block">Determine whether this is a container record by inspecting the
                                        option field.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i14" class="altColor">
                                <td class="colFirst"><code>protected int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#readHeader-byte:A-int-">readHeader</a></span>(byte[]&nbsp;data,
                                    int&nbsp;offset)</code>
                                    <div class="block">Reads the 8 byte header information and populates the <code>options</code>
                                        and <code>recordId</code> records.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i15" class="rowColor">
                                <td class="colFirst"><code>protected static short</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#readInstance-byte:A-int-">readInstance</a></span>(byte[]&nbsp;data,
                                    int&nbsp;offset)</code>
                                    <div class="block">Read the options field from header and return instance part of
                                        it.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i16" class="altColor">
                                <td class="colFirst"><code>byte[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#serialize--">serialize</a></span>()</code>
                                    <div class="block">Serializes to a new byte array.</div>
                                </td>
                            </tr>
                            <tr id="i17" class="rowColor">
                                <td class="colFirst"><code>int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#serialize-int-byte:A-">serialize</a></span>(int&nbsp;offset,
                                    byte[]&nbsp;data)</code>
                                    <div class="block">Serializes to an existing byte array without serialization
                                        listener.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i18" class="altColor">
                                <td class="colFirst"><code>abstract int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#serialize-int-byte:A-org.apache.poi.ddf.EscherSerializationListener-">serialize</a></span>(int&nbsp;offset,
                                    byte[]&nbsp;data,
                                    <a href="../../../../org/apache/poi/ddf/EscherSerializationListener.html"
                                       title="interface in org.apache.poi.ddf">EscherSerializationListener</a>&nbsp;listener)</code>
                                    <div class="block">Serializes the record to an existing byte array.</div>
                                </td>
                            </tr>
                            <tr id="i19" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#setChildRecords-java.util.List-">setChildRecords</a></span>(java.util.List&lt;<a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html"
                                        title="class in org.apache.poi.ddf">EscherRecord</a>&gt;&nbsp;childRecords)</code>
                                    <div class="block">Sets the child records for this record.</div>
                                </td>
                            </tr>
                            <tr id="i20" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#setInstance-short-">setInstance</a></span>(short&nbsp;value)</code>
                                    <div class="block">Sets the instance part of record</div>
                                </td>
                            </tr>
                            <tr id="i21" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#setOptions-short-">setOptions</a></span>(short&nbsp;options)</code>
                                    <div class="block">Set the options this this record.</div>
                                </td>
                            </tr>
                            <tr id="i22" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#setRecordId-short-">setRecordId</a></span>(short&nbsp;recordId)</code>
                                    <div class="block">Sets the record id for this record.</div>
                                </td>
                            </tr>
                            <tr id="i23" class="rowColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#setVersion-short-">setVersion</a></span>(short&nbsp;value)</code>
                                    <div class="block">Sets the version part of record</div>
                                </td>
                            </tr>
                            <tr id="i24" class="altColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#toString--">toString</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i25" class="rowColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#toXml--">toXml</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i26" class="altColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html#toXml-java.lang.String-">toXml</a></span>(java.lang.String&nbsp;tab)</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait</code>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="EscherRecord--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>EscherRecord</h4>
                                <pre>public&nbsp;EscherRecord()</pre>
                                <div class="block">Create a new instance</div>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="fillFields-byte:A-org.apache.poi.ddf.EscherRecordFactory-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>fillFields</h4>
                                <pre>protected&nbsp;int&nbsp;fillFields(byte[]&nbsp;data,
                         <a href="../../../../org/apache/poi/ddf/EscherRecordFactory.html"
                            title="interface in org.apache.poi.ddf">EscherRecordFactory</a>&nbsp;f)</pre>
                                <div class="block">Delegates to fillFields(byte[], int, EscherRecordFactory)</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>data</code> - they bytes to serialize from</dd>
                                    <dd><code>f</code> - the escher record factory</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The number of bytes written.</dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../org/apache/poi/ddf/EscherRecord.html#fillFields-byte:A-int-org.apache.poi.ddf.EscherRecordFactory-"><code>fillFields(byte[],
                                            int, org.apache.poi.ddf.EscherRecordFactory)</code></a></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="fillFields-byte:A-int-org.apache.poi.ddf.EscherRecordFactory-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>fillFields</h4>
                                <pre>public abstract&nbsp;int&nbsp;fillFields(byte[]&nbsp;data,
                               int&nbsp;offset,
                               <a href="../../../../org/apache/poi/ddf/EscherRecordFactory.html"
                                  title="interface in org.apache.poi.ddf">EscherRecordFactory</a>&nbsp;recordFactory)</pre>
                                <div class="block">The contract of this method is to deserialize an escher record
                                    including
                                    it's children.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>data</code> - The byte array containing the serialized escher
                                        records.
                                    </dd>
                                    <dd><code>offset</code> - The offset into the byte array.</dd>
                                    <dd><code>recordFactory</code> - A factory for creating new escher records.</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The number of bytes written.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readHeader-byte:A-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readHeader</h4>
                                <pre>protected&nbsp;int&nbsp;readHeader(byte[]&nbsp;data,
                         int&nbsp;offset)</pre>
                                <div class="block">Reads the 8 byte header information and populates the
                                    <code>options</code>
                                    and <code>recordId</code> records.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>data</code> - the byte array to read from</dd>
                                    <dd><code>offset</code> - the offset to start reading from</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the number of bytes remaining in this record. This
                                        may include the children if this is a container.
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readInstance-byte:A-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readInstance</h4>
                                <pre>protected static&nbsp;short&nbsp;readInstance(byte[]&nbsp;data,
                                    int&nbsp;offset)</pre>
                                <div class="block">Read the options field from header and return instance part of it.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>data</code> - the byte array to read from</dd>
                                    <dd><code>offset</code> - the offset to start reading from</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>value of instance part of options field</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="isContainerRecord--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>isContainerRecord</h4>
                                <pre>public&nbsp;boolean&nbsp;isContainerRecord()</pre>
                                <div class="block">Determine whether this is a container record by inspecting the option
                                    field.
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>true is this is a container field.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getOptions--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getOptions</h4>
                                <pre><a href="../../../../org/apache/poi/util/Internal.html"
                                        title="annotation in org.apache.poi.util">@Internal</a>
public&nbsp;short&nbsp;getOptions()</pre>
                                <div class="block">Note that <code>options</code> is an internal field.
                                    Use
                                    <a href="../../../../org/apache/poi/ddf/EscherRecord.html#setInstance-short-"><code>setInstance(short)</code></a>
                                    ()} and <a
                                            href="../../../../org/apache/poi/ddf/EscherRecord.html#setVersion-short-"><code>setVersion(short)</code></a>
                                    ()} to set the actual fields.
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The options field for this record. All records have one.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setOptions-short-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setOptions</h4>
                                <pre><a href="../../../../org/apache/poi/util/Internal.html"
                                        title="annotation in org.apache.poi.util">@Internal</a>
public&nbsp;void&nbsp;setOptions(short&nbsp;options)</pre>
                                <div class="block">Set the options this this record. Container records should have the
                                    last nibble set to 0xF.<p>

                                        Note that <code>options</code> is an internal field.
                                        Use <a
                                            href="../../../../org/apache/poi/ddf/EscherRecord.html#getInstance--"><code>getInstance()</code></a>
                                        and <a
                                            href="../../../../org/apache/poi/ddf/EscherRecord.html#getVersion--"><code>getVersion()</code></a>
                                        to access actual fields.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>options</code> - the record options</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="serialize--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>serialize</h4>
                                <pre>public&nbsp;byte[]&nbsp;serialize()</pre>
                                <div class="block">Serializes to a new byte array. This is done by delegating to
                                    serialize(int, byte[]);
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the serialized record.</dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../org/apache/poi/ddf/EscherRecord.html#serialize-int-byte:A-"><code>serialize(int,
                                            byte[])</code></a></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="serialize-int-byte:A-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>serialize</h4>
                                <pre>public&nbsp;int&nbsp;serialize(int&nbsp;offset,
                     byte[]&nbsp;data)</pre>
                                <div class="block">Serializes to an existing byte array without serialization listener.
                                    This is done by delegating to serialize(int, byte[], EscherSerializationListener).
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>offset</code> - the offset within the data byte array.</dd>
                                    <dd><code>data</code> - the data array to serialize to.</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The number of bytes written.</dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../org/apache/poi/ddf/EscherRecord.html#serialize-int-byte:A-org.apache.poi.ddf.EscherSerializationListener-"><code>serialize(int,
                                            byte[], org.apache.poi.ddf.EscherSerializationListener)</code></a></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="serialize-int-byte:A-org.apache.poi.ddf.EscherSerializationListener-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>serialize</h4>
                                <pre>public abstract&nbsp;int&nbsp;serialize(int&nbsp;offset,
                              byte[]&nbsp;data,
                              <a href="../../../../org/apache/poi/ddf/EscherSerializationListener.html"
                                 title="interface in org.apache.poi.ddf">EscherSerializationListener</a>&nbsp;listener)</pre>
                                <div class="block">Serializes the record to an existing byte array.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>offset</code> - the offset within the byte array</dd>
                                    <dd><code>data</code> - the data array to serialize to</dd>
                                    <dd><code>listener</code> - a listener for begin and end serialization events. This
                                        is useful because the serialization is
                                        hierarchical/recursive and sometimes you need to be able
                                        break into that.
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the number of bytes written.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getRecordSize--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getRecordSize</h4>
                                <pre>public abstract&nbsp;int&nbsp;getRecordSize()</pre>
                                <div class="block">Subclasses should effeciently return the number of bytes required to
                                    serialize the record.
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>number of bytes</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getRecordId--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getRecordId</h4>
                                <pre>public&nbsp;short&nbsp;getRecordId()</pre>
                                <div class="block">Return the current record id.</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The 16 bit record id.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setRecordId-short-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setRecordId</h4>
                                <pre>public&nbsp;void&nbsp;setRecordId(short&nbsp;recordId)</pre>
                                <div class="block">Sets the record id for this record.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>recordId</code> - the record id</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getChildRecords--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getChildRecords</h4>
                                <pre>public&nbsp;java.util.List&lt;<a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html"
                                        title="class in org.apache.poi.ddf">EscherRecord</a>&gt;&nbsp;getChildRecords()</pre>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>Returns the children of this record. By default this will
                                        be an empty list. EscherCotainerRecord is the only record
                                        that may contain children.
                                    </dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd><a href="../../../../org/apache/poi/ddf/EscherContainerRecord.html"
                                           title="class in org.apache.poi.ddf"><code>EscherContainerRecord</code></a>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setChildRecords-java.util.List-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setChildRecords</h4>
                                <pre>public&nbsp;void&nbsp;setChildRecords(java.util.List&lt;<a
                                        href="../../../../org/apache/poi/ddf/EscherRecord.html"
                                        title="class in org.apache.poi.ddf">EscherRecord</a>&gt;&nbsp;childRecords)</pre>
                                <div class="block">Sets the child records for this record. By default this will throw
                                    an exception as only EscherContainerRecords may have children.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>childRecords</code> - Not used in base implementation.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="clone--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>clone</h4>
                                <pre>public&nbsp;<a href="../../../../org/apache/poi/ddf/EscherRecord.html"
                                                    title="class in org.apache.poi.ddf">EscherRecord</a>&nbsp;clone()
                   throws java.lang.CloneNotSupportedException</pre>
                                <div class="block">Escher records may need to be clonable in the future.</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
                                    <dd><code>clone</code>&nbsp;in class&nbsp;<code>java.lang.Object</code></dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the cloned object</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.lang.CloneNotSupportedException</code> - if the subclass hasn't
                                        implemented <code>Cloneable</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getChild-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getChild</h4>
                                <pre>public&nbsp;<a href="../../../../org/apache/poi/ddf/EscherRecord.html"
                                                    title="class in org.apache.poi.ddf">EscherRecord</a>&nbsp;getChild(int&nbsp;index)</pre>
                                <div class="block">Returns the indexed child record.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>index</code> - the index of the child within the child records</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the indexed child record</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="display-java.io.PrintWriter-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>display</h4>
                                <pre>public&nbsp;void&nbsp;display(java.io.PrintWriter&nbsp;w,
                    int&nbsp;indent)</pre>
                                <div class="block">The display methods allows escher variables to print the record names
                                    according to their hierarchy.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>w</code> - The print writer to output to.</dd>
                                    <dd><code>indent</code> - The current indent level.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getRecordName--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getRecordName</h4>
                                <pre>public abstract&nbsp;java.lang.String&nbsp;getRecordName()</pre>
                                <div class="block">Subclasses should return the short name for this escher record.</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the short name for this escher record</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getInstance--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getInstance</h4>
                                <pre>public&nbsp;short&nbsp;getInstance()</pre>
                                <div class="block">Returns the instance part of the option record.</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The instance part of the record</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setInstance-short-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setInstance</h4>
                                <pre>public&nbsp;void&nbsp;setInstance(short&nbsp;value)</pre>
                                <div class="block">Sets the instance part of record</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>value</code> - instance part value</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getVersion--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getVersion</h4>
                                <pre>public&nbsp;short&nbsp;getVersion()</pre>
                                <div class="block">Returns the version part of the option record.</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The version part of the option record</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setVersion-short-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setVersion</h4>
                                <pre>public&nbsp;void&nbsp;setVersion(short&nbsp;value)</pre>
                                <div class="block">Sets the version part of record</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>value</code> - version part value</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="toXml--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>toXml</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;toXml()</pre>
                            </li>
                        </ul>
                        <a name="toXml-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>toXml</h4>
                                <pre>public final&nbsp;java.lang.String&nbsp;toXml(java.lang.String&nbsp;tab)</pre>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>tab</code> - - each children must be indented right relative to its parent
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>xml representation of this record</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="toString--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>toString</h4>
                                <pre>public final&nbsp;java.lang.String&nbsp;toString()</pre>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
                                    <dd><code>toString</code>&nbsp;in class&nbsp;<code>java.lang.Object</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getAttributeMap--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>getAttributeMap</h4>
                                <pre><a href="../../../../org/apache/poi/util/Internal.html"
                                        title="annotation in org.apache.poi.util">@Internal</a>
protected abstract&nbsp;java.lang.Object[][]&nbsp;getAttributeMap()</pre>
                                <div class="block">For the purpose of providing toString() and toXml() a subclass can
                                    either override those methods
                                    or provide a Object[][] array in the form <code>{ { "Attribute Name (Header)",
                                        value, "optional attribute", value }, ... } </code>.<p>

                                        Null values won't be printed.
                                    <p>

                                        The attributes record, version, instance, options must not be returned.</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the attribute map</dd>
                                    <dt><span class="simpleTagLabel">Since:</span></dt>
                                    <dd>POI 3.17-beta2</dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/EscherRecord.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../index-all.html">Index</a></li>
        <li><a href="../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../org/apache/poi/ddf/EscherPropertyMetaData.html"
               title="class in org.apache.poi.ddf"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../org/apache/poi/ddf/EscherRecordFactory.html"
               title="interface in org.apache.poi.ddf"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../index.html?org/apache/poi/ddf/EscherRecord.html" target="_top">Frames</a></li>
        <li><a href="EscherRecord.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
